//2-SAT
const int maxN = 1000;
vector <int> implies[maxN << 1];
int sat_val[maxN << 1], sat_vis[maxN << 1], sat_sort[maxN << 1], sat_ile;
inline void sat_or(int a, int b) {
	implies[a^1].push_back(b); implies[b^1].push_back(a);
}
void sat_dfs_mark(int x) {
	sat_vis[x] = 1; sat_val[x] = sat_val[x^1] == -1;
	for (vector <int> :: iterator it = implies[x].begin(); it != implies[x].end(); it ++)
		if (!sat_vis[*it]) sat_dfs_mark(*it);
}
void sat_dfs(int x){
	sat_vis[x] = 1;
	for (vector <int> :: iterator it = implies[x^1].begin(); it != implies[x^1].end(); it ++)
		if (!sat_vis[*it^1]) sat_dfs(*it^1);
	sat_sort[sat_ile++] = x;
}
int sat2(int n){
	sat_ile = 0;
	for (int i = 0; i < 2 * n; i ++) sat_vis[i] = 0, sat_val[i] = -1;
	for (int i = 0; i < 2 * n; i ++) if (!sat_vis[i]) sat_dfs(i);
	for (int i = 0; i < 2 * n; i ++) sat_vis[i] = 0;
	for (int i = 2 * n - 1; i >= 0; i --) if (!sat_vis[sat_sort[i]]) sat_dfs_mark(sat_sort[i]);
	for (int i = 0; i < 2 * n; i ++) if (sat_val[i])
		for (vector <int> :: iterator it = implies[i].begin(); it != implies[i].end(); it ++)
			if (!sat_val[*it]) return 0;
	return 1;
}
int main() {
	int m, n;
	scanf("%d %d", &n, &m);
	for (int i = 0; i < m; ++i) {
		int a, sa, b, sb, cnt = 0, x;
		while (scanf("%d", &x) == 1 && x) {
			if (!cnt){
				if (x > 0) a = x, sa = 1;
				else a = -x, sa = 0;
			}
			else {
				if (x > 0) b = x, sb = 1;
				else b = -x, sb = 0;
			}
			++cnt;
		}
		if (cnt == 1) b = a, sb = sa;
		--a, --b;
		sat_or(2 * a + (sa ^ 1), 2 * b + (sb ^ 1));
	}
	if (sat2(n)) {
		puts("Yes");
		for (int i = 0; i < n; i ++)
			if (sat_val[2 * i] == 1) printf("%d ", i + 1);
		puts("0");
	} else puts("No");
	return 0;
}

