//Minimal Circle
const int maxN = 100000 + 5;
const double EPS = 1e-8;
struct node
{
	double x, y;
}a[maxN];
int N;
double radius, rx, ry;
void init()
{
	scanf("%d", &N);
	for (int i = 1; i <= N; ++ i)
		scanf("%lf%lf", &a[i].x, &a[i].y);
}
void getcircle(node a, node b)
{
	rx = (a.x + b.x) / 2.0;
	ry = (a.y + b.y) / 2.0;
	radius = ((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y)) / 4.0;
}
bool incircle(node a)
{
	return (a.x - rx) * (a.x - rx) + (a.y - ry) * (a.y - ry) - radius < EPS;
}
void calc(node a, node b, node c)
{
	double a1 = 2 * (b.x - a.x);
	double b1 = 2 * (b.y - a.y);
	double c1 = b.x * b.x + b.y * b.y - a.x * a.x - a.y * a.y;
	double a2 = 2 * (c.x - a.x);
	double b2 = 2 * (c.y - a.y);
	double c2 = c.x * c.x + c.y * c.y - a.x * a.x - a.y * a.y;
	if (fabs(a1 * b2 - a2 * b1) < EPS)
	{
		getcircle(a, b);
		if (incircle(c)) return;
		getcircle(a, c);
		if (incircle(b)) return;
		getcircle(b, c);
		if (incircle(a)) return;
	} else
	{
		rx = (c2 * b1 - c1 * b2) / (b1 * a2 - b2 * a1);
		ry = (c2 * a1 - c1 * a2) / (a1 * b2 - a2 * b1);
		radius = (a.x - rx) * (a.x - rx) + (a.y - ry) * (a.y - ry);
	}
}
void shuffle()
{
	for (int i = 1; i <= N; ++ i)
	{
		int x = rand() % N + 1;
		int y = rand() % N + 1;
		swap(a[x], a[y]);
	}
}
void work()
{
	shuffle();
	getcircle(a[1], a[2]);
	for (int i = 3; i <= N; ++ i)
	{
		if (incircle(a[i])) continue;
		getcircle(a[1], a[i]);
		for (int j = 2; j < i; ++ j)
		{
			if (incircle(a[j])) continue;
			getcircle(a[i], a[j]);
			for (int k = 1; k < j; ++ k)
			{
				if (incircle(a[k])) continue;
				calc(a[i], a[j], a[k]);
			}
		}
	}
	printf("%.2lf\n", sqrt(radius));
	printf("%.2lf %.2lf\n", rx, ry);
}
int main()
{
	init();
	work();
	return 0;
}

