//Matching in Arbitrary Graph
//Random

const int rands = 1000;
const int maxn = 100;
const int maxnode = maxn + 1;

bool map[maxnode][maxnode];
bool cover[maxnode];

int ans;
int Qx[maxnode], Qy[maxnode];
int best[maxnode], links[maxnode];
int N, T;
int mat[maxnode][maxnode];

bool dfs(int i)
{
	cover[i] = 1;
	for (int j = 1; j <= N; j ++)
		if (map[i][Qy[j]] && !cover[Qy[j]])
		{
			cover[Qy[j]] = 1;
			int q = links[Qy[j]];
			if (!q || dfs(q))
			{
				links[Qy[j]] = i;
				links[i] = Qy[j];
				return 1;
			}
		}
	return 0;
}
void solve()
{
	memset(links, 0, sizeof(links));
	int sum = 0;
	for (int i = 1; i <= N; i ++)
		if (!links[Qx[i]])
		{
			memset(cover, 0, sizeof(cover));
			if (dfs(Qx[i])) sum ++;
		}
	if (sum > ans)
	{
		ans = sum;
		for (int i = 1; i <= N; i ++) best[i] = links[i];
	}
}
void randGen(int Q[])
{
	for (int i = 1; i <= N; i ++)
	{
		int x = rand() % N + 1;
		int y = rand() % N + 1;
		swap(Q[x], Q[y]);
	}
}
void work()
{
	memset(map, 0, sizeof(map));
	for (int i = 1; i <= N; ++ i)
		for (int j = 1; j <= N; ++ j)

			if (i != j)
			{
				// map[i][j] = ;
			}
	ans = 0;
	memset(best, 0, sizeof(best));
	for (int i = 1; i <= N; i ++) Qx[i] = Qy[i] = i;
	for (int k = 0; k < rands; k ++)
	{
		randGen(Qx);
		randGen(Qy);
		solve();
	}
	for (int i = 1; i <= N; ++ i)
		if (best[i] <= i)
			printf("%d %d\n", best[i], i);
}

