//Simplex
int main()
{
	int testcase;
	for (scanf("%d",&testcase);testcase>0;testcase--)
	{
		scanf("%d%d",&n,&m);
		memset(A,0,sizeof(A));
		memset(B,0,sizeof(B));
		memset(C,0,sizeof(C));
		for (int j=1;j<=n;j++)
			for (int i=1;i<=m;i++)
			{
				scanf("%lf",&A[i][j]);
				A[i][j]=-A[i][j]/100.0;
			}
		for (int i=1;i<=m;i++) A[i][n+i]=1,A[i][n+m+2]= 1,B[i]=0;
		for (int i=1;i<=n;i++) A[m+1][i]=1;
		A[m+1][n+m+1]=1;B[m+1]=1;
		for (int i=1;i<=m+1;i++) P[i]=n+i;
		C[n+m+2]=1;
		int _n=n,_m=m;
		n=_n+_m+2;
		m=_m+1;
		for (int i=1;i<=m;i++) A[i][0]=B[i];
		for (int i=1;i<=n;i++) Z[i]=C[i];
		while (1)
		{
			int s=-1;
			for (int i=1;i<=n;i++) if (s<0 || Z[i]>Z[s]) s=i;
			if (Z[s]<=eps) break;
			int r=-1;
			for (int i=1;i<=m;i++)
				if (A[i][s]>+eps && (r<0 || A[i][0]/A[i][
							s]<A[r][0]/A[r][s])) r=i;
			P[r]=s;
			double key=A[r][s];
			for (int i=1;i<=m;i++) if (i!=r)
			{
				double rate=A[i][s]/key;
				for (int j=0;j<=n;j++)
					A[i][j]-=rate*A[r][j];
			}
			double rZ=Z[s]/key;
			for (int j=1;j<=n;j++) Z[j]-=rZ*A[r][j];
			for (int j=0;j<=n;j++) A[r][j]/=key;
		}
		double result=0;
		for (int k=1;k<=m;k++)
			result+=C[P[k]]*A[k][0];
		printf("%0.6lf\n",result*100.0+eps);
	}
	return 0;
}

